;	C STARTUP CODE WITH DATA INITIALIZATION - CPU 0
;	Copyright (c) 2016 by COSMIC Software
;
	xdef	_exit, __stext
	xref.l	_main, __sdata, __sconst
	xref.l	__sram, __eram, __stack, __idesc__
	xref.l	__sbss, __memory
;
	vle	on
.vtext:	section	.text
;
atab:
	dc.l	__sdata			; init value of data pointer
	dc.l	__sram-4		; start of ram to clear
	dc.l	__eram-4		; end of ram to clear
	dc.l	__stack			; init value of stack pointer
	dc.l	__idesc__		; descriptor start address
	dc.l	__sconst		; init value of constant pointer
	dc.l	__sbss-4		; start of bss
	dc.l	__memory-4		; end of bss
__stext:
	lis	r5,0xfc05		; disable watchdog
	li	r0,0xc520		; SWT_0.SR.R = 0xc520
	stw	r0,16(r5)
	li	r0,0xd928		; SWT_0.SR.R = 0xd928
	stw	r0,16(r5)
	lis	r0,0xff00		; SWT_0.CR.R = 0xFF00010A
	ori	r0,0x010a
	stw	r0,0(r5)

	lis	r31,.atab		; get table
	addi	r31,.atab		; address
	lwz	r1,12(r31)		; initialize SP
	lwz	r4,4(r31)		; get start of ram
	lwz	r5,8(r31)		; get end of ram
	sub.	r5,r4			; byte size
	beq	init			; empty, skip
	addi	r5,127			; round up
	srwi	r5,7			; 128 bytes
	mtctr	r5			; set counter
eccbcl:
	stmw	r0,0(r4)		; write 32 registers
	addi	r4,128			; update address
	bdnz	eccbcl			; count down and loop back
	lwz	r4,24(r31)		; get start of bss
	lwz	r5,28(r31)		; get end of bss
	sub.	r5,r4			; byte size
	beq	init			; empty, skip
	srwi	r5,2			; word size
	li	r0,0			; to clear the bss
	mtctr	r5			; set counter
zbcl:
	stwu	r0,4(r4)		; clear memory
	bdnz	zbcl			; count down and loop back
init:
	lwz	r4,16(r31)		; descriptor address
	lwz	r5,0(r4)		; first image address
idbcl:
	subi	r5,4			; adjust address
dbcl:
	lwzu	r2,4(r4)		; get flag word
	cmpi	r2,0			; test flag
	beq	start			; end continue
	andis.	r2,$6000		; test for moveable code segment
	beq	skip			; yes, skip it
	lwzu	r6,4(r4)		; ram start address
	lwzu	r2,4(r4)		; code end address
	subi	r2,4			; adjust address
	sub	r2,r5			; block size
	srwi	r2,2			; word size
	mtctr	r2
	subi	r6,4			; adjust address
cbcl:
	lwzu	r0,4(r5)		; get and
	stwu	r0,4(r6)		; store
	bdnz	cbcl			; count down and loop back
	b	dbcl			; next segment
skip:
	lwzu	r5,8(r4)		; load next code address
	b	idbcl			; and loop back
start:
	lwz	r2,20(r31)		; initialize CP
	lwz	r13,0(r31)		; initialize DP
	bl	_main			; execute main
_exit:
	b	_exit			; stay here
;
	end
