#include <mpc5748g_401.h>

void system160mhz(void)
	{
	/* F160 - max 160 MHz */
	MC_CGM.SC_DC0.B.DIV = 0; /* Freq = sysclk / (0+1) = sysclk */
	MC_CGM.SC_DC0.B.DE = 1; /* Enable divided clock */
	/* S80 - max 80 MHz */
	/* MC_CGM_SC_DC1[DIV] and MC_CGM_SC_DC5[DIV] must be equal at all times */
	MC_CGM.SC_DC1.B.DIV = 1; /* Freq = sysclk / (2+1) = sysclk/2 */
	MC_CGM.SC_DC1.B.DE = 1; /* Enable divided clock */
	/* FS80 - max 80 MHz */
	/* MC_CGM_SC_DC1[DIV] and MC_CGM_SC_DC5[DIV] must be equal at all times */
	MC_CGM.SC_DC5.R = MC_CGM.SC_DC1.R; /* 80 MHz max */
	/* S40 - max 40 MHz */
	MC_CGM.SC_DC2.B.DIV = 3; /* Freq = sysclk / (3+1) = sysclk/4 */
	MC_CGM.SC_DC2.B.DE = 1; /* Enable divided clock */
	/* F40 - max 40 MHz (for PIT, etc.) - use default values */
	/* F80 - max 80 MHz - use default values*/
	/* F20 - clock out configured at clock_out* function */
	/* Connect XOSC to PLL */
	MC_CGM.AC5_SC.B.SELCTL = 1;              
	/* Configure PLL0 Dividers - 160MHz from 40Mhx XOSC */
	PLLDIG.PLLDV.B.PREDIV  = 2;
	PLLDIG.PLLDV.B.MFD     = 32;
	PLLDIG.PLLDV.B.RFDPHI  = 1;
	PLLDIG.PLLCAL3.R       = 0x09C3C000;
	PLLDIG.PLLFD.B.SMDEN   = 1;       /* Sigma delta modulation disabled */
	/* switch to PLL */
	MC_ME.DRUN_MC.R  = 0x00130172;    /* FLASH in normal mode, PLLON, FXOSC ON, Use PLL_PHI_0 */
	MC_ME.MCTL.R = 0x30005AF0;
	MC_ME.MCTL.R = 0x3000A50F;
	while (MC_ME.GS.B.S_MTRANS)	/* Wait for mode transition complete */
		;
	}
